//+------------------------------------------------------------------+
//|                                                       FIB_MA.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Dan"
#property  link      ""
//---- indicator settings

#property  indicator_separate_window
#property  indicator_buffers 8
#property indicator_minimum -30
#property indicator_maximum 30
#property  indicator_color1  Aqua
#property  indicator_color2  Red
#property  indicator_color3  Yellow
#property  indicator_color4  DodgerBlue
#property  indicator_color5  Tomato
#property  indicator_width1  3
#property  indicator_width2  3
#property  indicator_width3  3

//---- indicator parameters

extern int Fib_MA_MA_per=3;
extern int RSI_PER=10;



//---- indicator buffers

double     SignalUp[];
double     SignalDown[];

double Fib_MA[];
double Fib_MA_MA[];

double Fib_MA_1[];
double Fib_MA_MA_1[];

double RSI_Rapid[];
double RSI_Lent[];


datetime 	PrevTime;

int semnal=0, semnal_vechi=0, semnal_1=0, cont=0;


double a, b, c, d, e, f;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_NONE);
   SetIndexStyle(3,DRAW_NONE);
   SetIndexStyle(4,DRAW_NONE);
   SetIndexStyle(5,DRAW_NONE);
   SetIndexStyle(6,DRAW_NONE);
   SetIndexStyle(7,DRAW_NONE);
 
   
 
   IndicatorDigits(Digits+1);
   
//---- indicator buffers mapping
   SetIndexBuffer(0,SignalUp);
   SetIndexBuffer(1,SignalDown);
   SetIndexBuffer(2,Fib_MA);
   SetIndexBuffer(3,Fib_MA_MA);
   SetIndexBuffer(4,Fib_MA_1);
   SetIndexBuffer(5,Fib_MA_MA_1);
   SetIndexBuffer(6,RSI_Rapid);
   SetIndexBuffer(7,RSI_Lent);

   
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName(" 11 Studiu FIB MA");

   SetIndexLabel(0,"SignalUP");
   SetIndexLabel(1,"SignalDown");
 
   SetLevelValue(0,0);
   SetLevelValue(1,15);
   SetLevelValue(2,-15);
   SetLevelStyle(STYLE_DOT,1,DimGray);
  
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Studiu FIB_MAdicator                                             |
//+------------------------------------------------------------------+
int start()
  {
   int limit, i;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
//---------------------------------  
// Run only once per candle to take the picture of the situation only when a new candle occures
	if (PrevTime == Time[0])
		return;
	PrevTime = Time[0];
//---------------------------------  
     
//---- Fib_MA counted in the 1-st buffer
  
   for( i=0; i<limit; i++)

    {
    a=iCustom(NULL, 0, "HeikenAshi_DM",   3, i+1);
    b=iCustom(NULL, 0, "HeikenAshi_DM",   3, i+2);
    c=iCustom(NULL, 0, "HeikenAshi_DM",   3, i+3);
    d=iCustom(NULL, 0, "HeikenAshi_DM",   3, i+4);
    e=iCustom(NULL, 0, "HeikenAshi_DM",   3, i+5);
    f=iCustom(NULL, 0, "HeikenAshi_DM",   3, i+6);
    
    
    
     Fib_MA[i]=a+0.681*b+0.5*c+0.32*d+0.28*e+0.04*f;
     Fib_MA_1[i]=Close[i+1]+0.681*Close[i+2]+0.5*Close[i+3]+0.32*Close[i+4]+0.28*Close[i+5]+0.04*Close[i+6];
     RSI_Rapid[i]=iRSI(NULL,0,13,PRICE_CLOSE,i+1)-50;
     
    }  
 
 
   
//-------------------------------------------------------------------------

   for(int k=0; k<limit; k++)
   {
    Fib_MA_MA_1[k]=(Fib_MA_1[k]+Fib_MA_1[k+1]+Fib_MA_1[k+2])/3; 
    Fib_MA_MA[k]=(Fib_MA[k]+Fib_MA[k+1])/2; 
    RSI_Lent[k]=iMAOnArray(RSI_Rapid,0,RSI_PER,0,MODE_LWMA,k); 
   }

  if (cont==0)
 {   
   
   for(  k=0; k<limit; k++)
 
     {//deschidem bucla for
     

//----------------------------------------------------------------------     
                                
     if (Fib_MA[k]>Fib_MA_MA[k] && Fib_MA_1[k]>Fib_MA_MA_1[k] && RSI_Lent[k]>RSI_Lent[k+1] ) semnal=1;  // daca indeplinim conditiile  de intrare LONG---Atunci punem semnal =1
     if (Fib_MA[k]<Fib_MA_MA[k] && Fib_MA_1[k]<Fib_MA_MA_1[k] && RSI_Lent[k]<RSI_Lent[k+1] ) semnal=-1;  // daca indeplinim conditiile de intrare SHORT---Atunci punem semnal =-1
        
 
 //Afisam semnalele--------------------------------------------------
    if (semnal==1)  SignalUp[k]=RSI_Lent[k];
    if (semnal==-1) SignalDown[k]=RSI_Lent[k];
    
}//inchidem bucla for
}

 else
 {
//---------------------------------------------------------------------  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   
   
   
     if (Fib_MA[0]>Fib_MA_MA[0] && Fib_MA_1[0]>Fib_MA_MA_1[0] && RSI_Lent[0]>RSI_Lent[1] ) semnal=1;  // daca indeplinim conditiile  de intrare LONG---Atunci punem semnal =1
     if (Fib_MA[0]<Fib_MA_MA[0] && Fib_MA_1[0]<Fib_MA_MA_1[0] && RSI_Lent[0]<RSI_Lent[1]) semnal=-1;  // daca indeplinim conditiile de intrare SHORT---Atunci punem semnal =-1
        
 
 //Afisam semnalele--------------------------------------------------
    if (semnal==1)  SignalUp[0]=RSI_Lent[0];
    if (semnal==-1) SignalDown[0]=RSI_Lent[0];
   
   
   
    //----------------------------------------------------      
    //Plasam alertele de LONG + facem calculele
    if (semnal!= semnal_1 && semnal==1)                          // numai la o bara cu semnal diferit de cel precedent
        {
          Alert (Symbol( ) ,"  LONG  la  ", Close[1]);// Alerta daca suntem dupa un Short
        }

     //---------------------------------------------------------------------------------------------          
     //Plasam alertele de SHORT + facem calculele         
    if (semnal!= semnal_1 && semnal==-1)                          // numai la o bara cu semnal diferit de cel precedent
       {
         Alert ( Symbol( ) ,"  SHORT  la  ", Close[1]);// Alerta daca suntem dupa un Long
       }
  
   semnal_1=semnal;
}

cont++;
//---- done
   return(0);
  }
//+------------------------------------------------------------------+




















